/* Copyright 2004 Jetro Lauha - http://iki.fi/jetro/
 *
 * $Id: App.h,v 1.2 2004/10/17 21:42:04 tonic Exp $
 * $Revision: 1.2 $
 */

#ifndef APP_H_INCL
#define APP_H_INCL


#include <assert.h>


class State;


class App
{
public:

    typedef UINT32 STATE_TYPE;

    App();
    virtual ~App();

    static void setInstance(App *singleton);
    static App * getInstance()
    {
        assert(mSingleton != NULL);
        return mSingleton;
    }

    virtual BOOL init();

    virtual void run();

    virtual void setState(STATE_TYPE state);
    STATE_TYPE getState() const { return mState; }

    void setAlive(BOOL alive) { mAlive = alive; }
    BOOL isAlive() const { return mAlive; }

    SDL_Surface * getScreen() const { return mScreen; }

    INT getScreenWidth() { return getScreen()->w; }
    INT getScreenHeight() { return getScreen()->h; }

    State * getCurrentStateHandler() { return mCurrentStateHandler; }

protected:

    virtual BOOL update();

    void resetTime();

    virtual char * getCaption() = 0;
    virtual State * getStateHandler(STATE_TYPE state) = 0;

    static App *mSingleton;

    //! Current application state id. Initial state is 0.
    STATE_TYPE mState;

    SDL_Surface *mScreen;
    BOOL mAlive;
    UINT32 mTime, mStartTime;
    UINT32 mNextUpdateTime;

    State *mCurrentStateHandler;
    SDL_EventFilter mCustomEventFilter;
};


#endif // !APP_H_INCL
